## vboot-utils 0~R63

=== Makefile ===
# Copyright 2013 The Chromium OS Authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file.

# This Makefile normally builds in a 'build' subdir, but use
#
#    make BUILD=<dir>
#
# to put the output somewhere else.

##############################################################################
# Make variables come in two flavors, immediate or deferred.
#
#   Variable definitions are parsed like this:
#
#        IMMEDIATE = DEFERRED
#    or
#        IMMEDIATE := IMMEDIATE
#
#   Rules are parsed this way:
#
#        IMMEDIATE : IMMEDIATE
#           DEFERRED
#
# So you can assign variables in any order if they're only to be used in
# actions, but if you use a variable in either the target or prerequisite of a
# rule, the rule will be constructed using only the top-down, immediate value.
#
# So we'll try to define all the variables first. Then the rules.
#

##############################################################################
# Configuration variables come first.
#
# Our convention is that we only use := for variables that will never be
# changed or appended. They must be defined before being used anywhere.

# We should only run pwd once, not every time we refer to ${BUILD}.
SRCDIR := $(shell pwd)
export SRCDIR
BUILD = ${SRCDIR}/build
export BUILD

# Stuff for 'make install'
INSTALL = install
DESTDIR = /usr/local
LIBDIR ?= lib

# Default values
DEV_DEBUG_FORCE=

# Where exactly do the pieces go?
#  UB_DIR = utility binary directory
#  ULP_DIR = pkgconfig directory, usually /usr/lib/pkgconfig
#  UI_DIR = include directory for library headers
#  US_DIR = shared data directory (for static content like devkeys)
#  DF_DIR = utility defaults directory
#  VB_DIR = vboot binary directory for dev-mode-only scripts
ifeq (${MINIMAL},)
# Host install just puts everything where it's told
UB_DIR=${DESTDIR}/bin
UL_DIR=${DESTDIR}/${LIBDIR}
ULP_DIR=${UL_DIR}/pkgconfig
UI_DIR=${DESTDIR}/include/vboot
US_DIR=${DESTDIR}/share/vboot
DF_DIR=${DESTDIR}/default
VB_DIR=${DESTDIR}/bin
else
# Target install puts things into different places
UB_DIR=${DESTDIR}/usr/bin
UL_DIR=${DESTDIR}/usr/${LIBDIR}
ULP_DIR=${UL_DIR}/pkgconfig
UI_DIR=${DESTDIR}/usr/include/vboot
US_DIR=${DESTDIR}/usr/share/vboot
DF_DIR=${DESTDIR}/etc/default
VB_DIR=${US_DIR}/bin
endif

# Where to install the (exportable) executables for testing?
TEST_INSTALL_DIR = ${BUILD}/install_for_test

# Verbose? Use V=1
ifeq (${V},)
Q := @
endif

# Quiet? Use QUIET=1
ifeq (${QUIET},)
PRINTF := printf
else
PRINTF := :
endif

# Architecture detection
_machname := $(shell uname -m)
HOST_ARCH ?= ${_machname}

# ARCH and/or FIRMWARE_ARCH are defined by the Chromium OS ebuild.
# Pick a sane target architecture if none is defined.
ifeq (${ARCH},)
  ARCH := ${HOST_ARCH}
endif

ifeq (${ARCH},armv7l)
  override ARCH := arm
else ifeq (${ARCH},i386)
  override ARCH := x86
else ifeq (${ARCH},i686)
  override ARCH := x86
else ifeq (${ARCH},amd64)
  override ARCH := x86_64
endif

# FIRMWARE_ARCH is only defined by the Chromium OS ebuild if compiling
# for a firmware target (such as u-boot or depthcharge). It must map
# to the same consistent set of architectures as the host.
ifeq (${FIRMWARE_ARCH},i386)
  override FIRMWARE_ARCH := x86
else ifeq (${FIRMWARE_ARCH},amd64)
  override FIRMWARE_ARCH := x86_64
else ifeq (${FIRMWARE_ARCH},armv7)
  override FIRMWARE_ARCH := arm
endif

# Provide default CC and CFLAGS for firmware builds; if you have any -D flags,
# please add them after this point (e.g., -DVBOOT_DEBUG).
#
# TODO(crosbug.com/16808) We hard-code u-boot's compiler flags here just
# temporarily. As we are still investigating which flags are necessary for
# maintaining a compatible ABI, etc. between u-boot and vboot_reference.
#
# As a first step, this makes the setting of CC and CFLAGS here optional, to
# permit a calling script or Makefile to set these.
#
# Flag ordering: arch, then -f, then -m, then -W
DEBUG_FLAGS := $(if ${DEBUG},-g -O0,-Os)
WERROR := -Werror
COMMON_FLAGS := -nostdinc -pipe \
	-ffreestanding -fno-builtin -fno-stack-protector \
	${WERROR} -Wall -Wstrict-prototypes ${DEBUG_FLAGS}

# Note: FIRMWARE_ARCH is defined by the Chromium OS ebuild.
ifeq (${FIRMWARE_ARCH}, arm)
CC ?= armv7a-cros-linux-gnueabi-gcc
CFLAGS ?= -march=armv5 \
	-fno-common -ffixed-r8 \
	-mfloat-abi=hard -marm -mabi=aapcs-linux -mno-thumb-interwork \
	${COMMON_FLAGS}
else ifeq (${FIRMWARE_ARCH}, x86)
CC ?= i686-pc-linux-gnu-gcc
# Drop -march=i386 to permit use of SSE instructions
CFLAGS ?= \
	-ffunction-sections -fvisibility=hidden -fno-strict-aliasing \
	-fomit-frame-pointer -fno-toplevel-reorder -fno-dwarf2-cfi-asm \
	-mpreferred-stack-boundary=2 \
	${COMMON_FLAGS}
else ifeq (${FIRMWARE_ARCH}, x86_64)
CFLAGS ?= ${COMMON_FLAGS} \
	-fvisibility=hidden -fno-strict-aliasing -fomit-frame-pointer
else
# FIRMWARE_ARCH not defined; assuming local compile.
CC ?= gcc
CFLAGS += -DCHROMEOS_ENVIRONMENT -Wall ${WERROR} ${DEBUG_FLAGS}
endif

ifneq (${CUSTOM_MUSIC},)
CFLAGS += -DCUSTOM_MUSIC
endif

ifneq (${DEBUG},)
CFLAGS += -DVBOOT_DEBUG
endif

ifeq (${DISABLE_NDEBUG},)
CFLAGS += -DNDEBUG
endif

ifneq (${FORCE_LOGGING_ON},)
CFLAGS += -DFORCE_LOGGING_ON=${FORCE_LOGGING_ON}
endif

ifneq (${PD_SYNC},)
CFLAGS += -DPD_SYNC
endif

ifneq (${USE_MTD},)
CFLAGS += -DUSE_MTD
LDLIBS += -lmtdutils
endif

ifneq (${TPM2_MODE},)
CFLAGS += -DTPM2_MODE
endif

# NOTE: We don't use these files but they are useful for other packages to
# query about required compiling/linking flags.
PC_IN_FILES = vboot_host.pc.in

# Create / use dependency files
CFLAGS += -MMD -MF $@.d

ifeq (${FIRMWARE_ARCH},)
# Creates position independent code for non firmware target.
CFLAGS += -fPIE
endif

# These are required to access large disks and files on 32-bit systems.
CFLAGS += -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64

# Code coverage
ifneq (${COV},)
  COV_FLAGS = -O0 --coverage -DCOVERAGE
  CFLAGS += ${COV_FLAGS}
  LDFLAGS += ${COV_FLAGS}
  COV_INFO = ${BUILD}/coverage.info
endif

ifdef HAVE_MACOS
  CFLAGS += -DHAVE_MACOS -Wno-deprecated-declarations
endif

# Musl doesn't have execinfo.h.
ifndef HAVE_MUSL
  CFLAGS += -DHAVE_EXECINFO_H
endif

# And a few more default utilities
LD = ${CC}
CXX ?= g++
PKG_CONFIG ?= pkg-config

# Static?
ifneq (${STATIC},)
LDFLAGS += -static
PKG_CONFIG += --static
endif

# Determine QEMU architecture needed, if any
ifeq (${ARCH},${HOST_ARCH})
  # Same architecture; no need for QEMU
  QEMU_ARCH :=
else ifeq (${HOST_ARCH}-${ARCH},x86_64-x86)
  # 64-bit host can run 32-bit targets directly
  QEMU_ARCH :=
else
  QEMU_ARCH := ${ARCH}
endif

# The top of the chroot for qemu must be passed in via the SYSROOT environment
# variable.  In the Chromium OS chroot, this is done automatically by the
# ebuild.

ifeq (${QEMU_ARCH},)
  # Path to build output for running tests is same as for building
  BUILD_RUN = ${BUILD}
  SRC_RUN = ${SRCDIR}
else
  $(info Using qemu for testing.)
  # Path to build output for running tests is different in the chroot
  BUILD_RUN = $(subst ${SYSROOT},,${BUILD})
  SRC_RUN = $(subst ${SYSROOT},,${SRCDIR})

  QEMU_BIN = qemu-${QEMU_ARCH}
  QEMU_RUN = ${BUILD_RUN}/${QEMU_BIN}
  export QEMU_RUN

  RUNTEST = tests/test_using_qemu.sh
endif

export BUILD_RUN

##############################################################################
# The default target is here, to allow dependencies to be expressed below
# without accidentally changing the default target.

# Default target.
.PHONY: all
all: fwlib fwlib2x fwlib20 fwlib21 \
	$(if ${FIRMWARE_ARCH},,host_stuff) \
	$(if ${COV},coverage)

##############################################################################
# Now we need to describe everything we might want or need to build

# Everything wants these headers.
INCLUDES += \
	-Ifirmware/include \
	-Ifirmware/lib/include \
	-Ifirmware/lib/cgptlib/include \
	-Ifirmware/lib/cryptolib/include \
	-Ifirmware/lib/tpm_lite/include \
	-Ifirmware/2lib/include \
	-Ifirmware/lib20/include

# If we're not building for a specific target, just stub out things like the
# TPM commands and various external functions that are provided by the BIOS.
ifeq (${FIRMWARE_ARCH},)
INCLUDES += -Ihost/include -Ihost/lib/include
INCLUDES += -Ihost/lib21/include -Ifirmware/lib21/include
endif

# Firmware library, used by the other firmware components (depthcharge,
# coreboot, etc.). It doesn't need exporting to some other place; they'll build
# this source tree locally and link to it directly.
FWLIB = ${BUILD}/vboot_fw.a

# Smaller firmware library common to all vboot 2.x, used only for
# 1) compile-time tests of the public API or
# 2) linking with an actual 2.0 or 2.1 implementation
FWLIB2X = ${BUILD}/vboot_fw2x.a

# Vboot 2.0 (deprecated - see firmware/README)
FWLIB20 = ${BUILD}/vboot_fw20.a
# Vboot 2.1 (not yet ready - see firmware/README)
FWLIB21 = ${BUILD}/vboot_fw21.a

# Static library containing firmware APIs for common boot flow
BDBLIB = ${BUILD}/bdb.a

# Firmware library sources needed by VbInit() call
VBINIT_SRCS = \
	firmware/lib/vboot_common_init.c \
	firmware/lib/vboot_nvstorage.c \
	firmware/lib/region-init.c \

# Additional firmware library sources needed by VbSelectFirmware() call
VBSF_SRCS = \
	firmware/lib/vboot_common.c \
	firmware/lib/region-fw.c \

# Additional firmware library sources needed by VbSelectAndLoadKernel() call
VBSLK_SRCS = \
	firmware/lib/cgptlib/cgptlib.c \
	firmware/lib/cgptlib/cgptlib_internal.c \
	firmware/lib/cgptlib/crc32.c \
	firmware/lib/ec_sync.c \
	firmware/lib/ec_sync_all.c \
	firmware/lib/gpt_misc.c \
	firmware/lib/utility_string.c \
	firmware/lib/vboot_api_kernel.c \
	firmware/lib/vboot_audio.c \
	firmware/lib/vboot_display.c \
	firmware/lib/vboot_kernel.c \
	firmware/lib/vboot_ui.c \
	firmware/lib/vboot_ui_menu.c \
	firmware/lib/region-kernel.c \

# Code common to both vboot 2.0 (old structs) and 2.1 (new structs)
FWLIB2X_SRCS = \
	firmware/2lib/2api.c \
	firmware/2lib/2common.c \
	firmware/2lib/2crc8.c \
	firmware/2lib/2misc.c \
	firmware/2lib/2nvstorage.c \
	firmware/2lib/2rsa.c \
	firmware/2lib/2secdata.c \
	firmware/2lib/2secdatak.c \
	firmware/2lib/2sha1.c \
	firmware/2lib/2sha256.c \
	firmware/2lib/2sha512.c \
	firmware/2lib/2sha_utility.c \
	firmware/2lib/2tpm_bootmode.c \
	firmware/2lib/2hmac.c

FWLIB20_SRCS = \
	firmware/lib20/api.c \
	firmware/lib20/api_kernel.c \
	firmware/lib20/common.c \
	firmware/lib20/kernel.c \
	firmware/lib20/misc.c \
	firmware/lib20/packed_key.c

FWLIB21_SRCS = \
	firmware/lib21/api.c \
	firmware/lib21/common.c \
	firmware/lib21/misc.c \
	firmware/lib21/packed_key.c

BDBLIB_SRCS = \
	firmware/bdb/bdb.c \
	firmware/bdb/ecdsa.c \
	firmware/bdb/misc.c \
	firmware/bdb/rsa.c \
	firmware/bdb/secrets.c \
	firmware/bdb/sha.c \
	firmware/bdb/stub.c \
	firmware/bdb/nvm.c

# TPM lightweight command library
ifeq (${TPM2_MODE},)
TLCL_SRCS = \
	firmware/lib/tpm_lite/tlcl.c
else
TLCL_SRCS = \
	firmware/lib/tpm2_lite/tlcl.c \
	firmware/lib/tpm2_lite/marshaling.c
endif
TLCL_OBJS_FOR_TEST = $(TLCL_SRCS:%.c=${BUILD}/%_for_test.o)

# Support real TPM unless BIOS sets MOCK_TPM
ifeq (${MOCK_TPM},)
VBINIT_SRCS += \
	firmware/lib/rollback_index.c \
	${TLCL_SRCS}
else
VBINIT_SRCS += \
	firmware/lib/mocked_rollback_index.c \
	firmware/lib/tpm_lite/mocked_tlcl.c
endif

ifeq (${FIRMWARE_ARCH},)
# Include BIOS stubs in the firmware library when compiling for host
# TODO: split out other stub funcs too
VBINIT_SRCS += \
	firmware/stub/tpm_lite_stub.c \
	firmware/stub/vboot_api_stub_init.c \
	firmware/stub/vboot_api_stub_region.c

VBSLK_SRCS += \
	firmware/stub/vboot_api_stub.c \
	firmware/stub/vboot_api_stub_disk.c \
	firmware/stub/vboot_api_stub_stream.c

FWLIB2X_SRCS += \
	firmware/2lib/2stub.c

endif

VBSF_SRCS += ${VBINIT_SRCS}
FWLIB_SRCS += ${VBSF_SRCS} ${VBSLK_SRCS}

VBINIT_OBJS = ${VBINIT_SRCS:%.c=${BUILD}/%.o}
VBSF_OBJS = ${VBSF_SRCS:%.c=${BUILD}/%.o}
ALL_OBJS +=  ${VBINIT_OBJS} ${VBSF_OBJS}

FWLIB_OBJS = ${FWLIB_SRCS:%.c=${BUILD}/%.o}

## vboot-utils 0~R63-10032.B

=== debian/changelog ===
vboot-utils (0~R63-10032.B-3) unstable; urgency=medium

  * Move git repository to salsa.debian.org.
  * Make build logs verbose to include the full command line.
  * Protect dh_override_auto_test with check of nocheck in DEB_BUILD_OPTIONS.
  * Bump Standards-Version to 4.1.3.
  * Update my name in Uploaders.

 -- Raphaël Hertzog <hertzog@debian.org>  Tue, 06 Feb 2018 16:29:11 +0100

vboot-utils (0~R63-10032.B-2) unstable; urgency=medium

  * Add a patch to fix futility bdb on 32 bits architectures (Closes: #881997)

 -- Sophie Brun <sophie@freexian.com>  Mon, 20 Nov 2017 14:19:32 +0100

vboot-utils (0~R63-10032.B-1) unstable; urgency=medium

  * Fix debian/watch
  * New upstream version 0~R63-10032.B
  * Build against openssl 1.1 (Closes: #835801)
  * Remove useless patch 0001-use-zu-as-appropriate-for-size_t (fixed
    upstream)
  * Update debian/copyright
  * Remove useless patch 0009-drop-failing-test.patch
  * Add a patch to fix failing tests-show-contents
  * Bump Standards-version to 4.1.1: update Priority to optional, use https
  * Fix perms for usr/share/vboot/bin/common_minimal.sh

 -- Sophie Brun <sophie@freexian.com>  Thu, 16 Nov 2017 09:21:28 +0100

=== debian/control ===
Source: vboot-utils
Section: admin
Priority: optional
Maintainer: Sophie Brun <sophie@freexian.com>
Uploaders: Raphaël Hertzog <hertzog@debian.org>
Build-Depends: debhelper (>= 9),
               liblzma-dev,
               libssl-dev,
               libyaml-dev,
               pkg-config,
               uuid-dev,
# tests/bitmaps/TestBmpBlock.py
               python,
# tests/external_rsa_signer.sh
               openssl
Standards-Version: 4.1.3
Vcs-Git: https://salsa.debian.org/debian/vboot-utils.git
Vcs-Browser: https://salsa.debian.org/debian/vboot-utils
Homepage: https://chromium.googlesource.com/chromiumos/platform/vboot_reference

Package: vboot-utils
Architecture: amd64 arm64 armel armhf i386
Multi-Arch: foreign
Depends: vboot-kernel-utils, ${misc:Depends}, ${shlibs:Depends}
Recommends: cgpt
Pre-Depends: ${misc:Pre-Depends}
Description: Chrome OS verified u-boot utilities
 This package contains a set of tools to deal with Chromebook internals,
 and the verified version of u-boot. Namely:
 bmpblk_font bmpblk_utility chromeos-tpm-recovery crossystem dev_debug_vboot
 dev_make_keypair dumpRSAPublicKey eficompress efidecompress enable_dev_usb_boot
 load_kernel_test pad_digest_utility signature_digest_utility tpm-nvsize
 tpm_init_temp_fix tpmc vbutil_what_key verify_data.
 .
 The programs previously included in this package: dump_fmap dump_kernel_config
 futility gbb_utility  vbutil_firmware vbutil_key vbutil_keyblock, are now
 grouped in the futility program in the package vboot-kernel-utils.
 .
 Most users don't need this package, and should look for the cgpt and
 vboot-kernel-utils packages instead.

Package: cgpt
Provides: crossystem
Architecture: amd64 arm64 armel armhf i386
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: GPT manipulation tool with support for Chromium OS extensions
 Cgpt is a tool to manipulate GUID Partition Table from command line. It also
 supports Chromium OS extensions enabling you to change priority for kernel
 partitions.

Package: vboot-kernel-utils
Architecture: amd64 arm64 armel armhf i386
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Chrome OS verified boot utils required to sign kernels
 This package provides the futility program (including the vbutil_kernel
 program required to sign custom kernels in order to get them booted by Chrome
 OS devices (i.e. Chromebooks)).

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

override_dh_auto_build:
	dh_auto_build -- V=1

override_dh_auto_install:
	$(MAKE) V=1 DESTDIR=$$(pwd)/debian/vboot-utils/usr install
	mkdir -p $$(pwd)/debian/cgpt/usr/bin
	mv -t $$(pwd)/debian/cgpt/usr/bin \
	        $$(pwd)/debian/vboot-utils/usr/bin/cgpt
	mkdir -p $$(pwd)/debian/vboot-kernel-utils/usr/bin
	mv -t $$(pwd)/debian/vboot-kernel-utils/usr/bin \
	        $$(pwd)/debian/vboot-utils/usr/bin/vbutil_kernel
	mv -t $$(pwd)/debian/vboot-kernel-utils/usr/bin \
	        $$(pwd)/debian/vboot-utils/usr/bin/futility
	mv -t $$(pwd)/debian/vboot-kernel-utils/usr/bin \
	        $$(pwd)/debian/vboot-utils/usr/bin/futility_s
	# vboot_host.pc is useless without the static library (which
	# we could install with "make install-dev" but we currently don't)
	rm -f debian/vboot-utils/usr/lib/pkgconfig/vboot_host.pc
	rmdir --ignore-fail-on-non-empty -p debian/vboot-utils/usr/lib/pkgconfig

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	make runtests V=1
endif

%:
	dh $@ --parallel

override_dh_fixperms:
	dh_fixperms
	chmod 755 debian/vboot-utils/usr/share/vboot/bin/common_minimal.sh

=== debian/watch ===
version=3
opts="downloadurlmangle=s|/\+/release-(.*)|/+archive/release-$1.tar.gz|g,uversionmangle=s|^|0~|,filenamemangle=s|.*/release-(.*)$|vboot-utils-$1.tar.gz|" \
https://chromium.googlesource.com/chromiumos/platform/vboot_reference/+refs \
 /chromiumos/platform/vboot_reference/\+/release-(.*)

## vboot-utils 0~R81

=== Makefile ===
--- 
+++ 
@@ -103,6 +103,8 @@
 
 ifeq (${ARCH},armv7l)
   override ARCH := arm
+else ifneq (,$(filter aarch64 arm64,${ARCH}))
+  override ARCH := arm
 else ifeq (${ARCH},i386)
   override ARCH := x86
 else ifeq (${ARCH},i686)
@@ -133,39 +135,37 @@
 # permit a calling script or Makefile to set these.
 #
 # Flag ordering: arch, then -f, then -m, then -W
-DEBUG_FLAGS := $(if ${DEBUG},-g -O0,-Os)
+DEBUG_FLAGS := $(if ${DEBUG},-g -O0,-g -Os)
 WERROR := -Werror
-COMMON_FLAGS := -nostdinc -pipe \
-	-ffreestanding -fno-builtin -fno-stack-protector \
-	${WERROR} -Wall -Wstrict-prototypes ${DEBUG_FLAGS}
+FIRMWARE_FLAGS := -nostdinc -ffreestanding -fno-builtin -fno-stack-protector
+COMMON_FLAGS := -pipe ${WERROR} -Wall -Wstrict-prototypes -Wtype-limits \
+	-Wundef -Wmissing-prototypes -Wno-trigraphs -Wredundant-decls -Wshadow \
+	-Wwrite-strings -Wstrict-aliasing -Wdate-time -Wno-unknown-warning \
+	-Wno-address-of-packed-member -ffunction-sections -fdata-sections \
+	-Wimplicit-fallthrough -Wformat -Wno-format-security ${DEBUG_FLAGS}
 
 # Note: FIRMWARE_ARCH is defined by the Chromium OS ebuild.
-ifeq (${FIRMWARE_ARCH}, arm)
-CC ?= armv7a-cros-linux-gnueabi-gcc
-CFLAGS ?= -march=armv5 \
-	-fno-common -ffixed-r8 \
-	-mfloat-abi=hard -marm -mabi=aapcs-linux -mno-thumb-interwork \
-	${COMMON_FLAGS}
-else ifeq (${FIRMWARE_ARCH}, x86)
+ifeq (${FIRMWARE_ARCH},arm)
+CC ?= armv7a-cros-linux-gnueabihf-gcc
+CFLAGS ?= -march=armv5 -fno-common -ffixed-r8 -mfloat-abi=hard -marm
+	-mabi=aapcs-linux -mno-thumb-interwork ${FIRMWARE_FLAGS} ${COMMON_FLAGS}
+else ifeq (${FIRMWARE_ARCH},x86)
 CC ?= i686-pc-linux-gnu-gcc
 # Drop -march=i386 to permit use of SSE instructions
-CFLAGS ?= \
-	-ffunction-sections -fvisibility=hidden -fno-strict-aliasing \
-	-fomit-frame-pointer -fno-toplevel-reorder -fno-dwarf2-cfi-asm \
-	-mpreferred-stack-boundary=2 \
-	${COMMON_FLAGS}
-else ifeq (${FIRMWARE_ARCH}, x86_64)
-CFLAGS ?= ${COMMON_FLAGS} \
-	-fvisibility=hidden -fno-strict-aliasing -fomit-frame-pointer
+CFLAGS ?= -fvisibility=hidden -fomit-frame-pointer \
+	-fno-toplevel-reorder -fno-dwarf2-cfi-asm -mpreferred-stack-boundary=2 \
+	${FIRMWARE_FLAGS} ${COMMON_FLAGS}
+else ifeq (${FIRMWARE_ARCH},x86_64)
+CFLAGS ?= ${FIRMWARE_FLAGS} ${COMMON_FLAGS} -fvisibility=hidden \
+	-fomit-frame-pointer
 else
 # FIRMWARE_ARCH not defined; assuming local compile.
 CC ?= gcc
-CFLAGS += -DCHROMEOS_ENVIRONMENT -Wall ${WERROR} ${DEBUG_FLAGS}
-endif
-
-ifneq (${CUSTOM_MUSIC},)
-CFLAGS += -DCUSTOM_MUSIC
-endif
+CFLAGS += -DCHROMEOS_ENVIRONMENT ${COMMON_FLAGS}
+endif
+
+# Needs -Wl because LD is actually set to CC by default.
+LDFLAGS ?= -Wl,--gc-sections
 
 ifneq (${DEBUG},)
 CFLAGS += -DVBOOT_DEBUG
@@ -179,17 +179,55 @@
 CFLAGS += -DFORCE_LOGGING_ON=${FORCE_LOGGING_ON}
 endif
 
-ifneq (${PD_SYNC},)
-CFLAGS += -DPD_SYNC
-endif
-
-ifneq (${USE_MTD},)
-CFLAGS += -DUSE_MTD
-LDLIBS += -lmtdutils
-endif
-
 ifneq (${TPM2_MODE},)
 CFLAGS += -DTPM2_MODE
+endif
+
+# Enable USB boot when switching to dev mode
+ifneq ($(filter-out 0,${USB_BOOT_ON_DEV}),)
+CFLAGS += -DUSB_BOOT_ON_DEV=1
+else
+CFLAGS += -DUSB_BOOT_ON_DEV=0
+endif
+
+# EC software sync is slow to update. Enable warning screen display.
+ifneq ($(filter-out 0,${EC_SLOW_UPDATE}),)
+CFLAGS += -DEC_SLOW_UPDATE=1
+else
+CFLAGS += -DEC_SLOW_UPDATE=0
+endif
+
+# Enable EC early firmware selection.
+ifneq ($(filter-out 0,${EC_EFS}),)
+CFLAGS += -DEC_EFS=1
+else
+CFLAGS += -DEC_EFS=0
+endif
+
+# Some tests need to be disabled when using mocked_secdata_tpm.
+ifneq (${MOCK_TPM},)
+CFLAGS += -DMOCK_TPM
+endif
+
+# LEGACY_MENU_UI controls whether to enable legacy menu UI, which is used with
+# devices that don't have a keyboard (detachables).
+# Pass LEGACY_MENU_UI= (or =0) to make to disable feature.
+ifneq ($(filter-out 0,${LEGACY_MENU_UI}),)
+CFLAGS += -DLEGACY_MENU_UI=1
+else
+CFLAGS += -DLEGACY_MENU_UI=0
+endif
+
+# enable all features during local compile (permits testing)
+ifeq (${FIRMWARE_ARCH},)
+DIAGNOSTIC_UI := 1
+endif
+
+# pass DIAGNOSTIC_UI= (or =0) to make to disable feature
+ifneq ($(filter-out 0,${DIAGNOSTIC_UI}),)
+CFLAGS += -DDIAGNOSTIC_UI=1
+else
+CFLAGS += -DDIAGNOSTIC_UI=0
 endif
 
 # NOTE: We don't use these files but they are useful for other packages to
@@ -233,6 +271,18 @@
 ifneq (${STATIC},)
 LDFLAGS += -static
 PKG_CONFIG += --static
+endif
+
+ifneq (${FUZZ_FLAGS},)
+CFLAGS += ${FUZZ_FLAGS}
+endif
+
+# Optional Libraries
+LIBZIP_VERSION := $(shell ${PKG_CONFIG} --modversion libzip 2>/dev/null)
+HAVE_LIBZIP := $(if ${LIBZIP_VERSION},1)
+ifneq (${HAVE_LIBZIP},)
+  CFLAGS += -DHAVE_LIBZIP $(shell ${PKG_CONFIG} --cflags libzip)
+  LIBZIP_LIBS := $(shell ${PKG_CONFIG} --libs libzip)
 endif
 
 # Determine QEMU architecture needed, if any
@@ -275,7 +325,7 @@
 
 # Default target.
 .PHONY: all
-all: fwlib fwlib2x fwlib20 fwlib21 \
+all: $(if ${NO_BUILD_TOOLS},,fwlib fwlib2x fwlib20 fwlib21 tlcl) \
 	$(if ${FIRMWARE_ARCH},,host_stuff) \
 	$(if ${COV},coverage)
 
@@ -314,27 +364,14 @@
 # Vboot 2.1 (not yet ready - see firmware/README)
 FWLIB21 = ${BUILD}/vboot_fw21.a
 
-# Static library containing firmware APIs for common boot flow
-BDBLIB = ${BUILD}/bdb.a
-
-# Firmware library sources needed by VbInit() call
-VBINIT_SRCS = \
-	firmware/lib/vboot_common_init.c \
-	firmware/lib/vboot_nvstorage.c \
-	firmware/lib/region-init.c \
-
-# Additional firmware library sources needed by VbSelectFirmware() call
-VBSF_SRCS = \
-	firmware/lib/vboot_common.c \
-	firmware/lib/region-fw.c \
+# Separate TPM lightweight command library (TLCL)
+TLCL = ${BUILD}/tlcl.a
 
 # Additional firmware library sources needed by VbSelectAndLoadKernel() call
-VBSLK_SRCS = \
+FWLIB_SRCS = \
 	firmware/lib/cgptlib/cgptlib.c \
 	firmware/lib/cgptlib/cgptlib_internal.c \
 	firmware/lib/cgptlib/crc32.c \
-	firmware/lib/ec_sync.c \
-	firmware/lib/ec_sync_all.c \
 	firmware/lib/gpt_misc.c \
 	firmware/lib/utility_string.c \
 	firmware/lib/vboot_api_kernel.c \
@@ -342,19 +379,24 @@
 	firmware/lib/vboot_display.c \
 	firmware/lib/vboot_kernel.c \
 	firmware/lib/vboot_ui.c \
-	firmware/lib/vboot_ui_menu.c \
-	firmware/lib/region-kernel.c \
+	firmware/lib/vboot_ui_common.c \
+	firmware/lib/vboot_ui_menu.c
 
 # Code common to both vboot 2.0 (old structs) and 2.1 (new structs)
 FWLIB2X_SRCS = \
 	firmware/2lib/2api.c \
+	firmware/2lib/2auxfw_sync.c \
 	firmware/2lib/2common.c \
+	firmware/2lib/2context.c \
 	firmware/2lib/2crc8.c \
+	firmware/2lib/2ec_sync.c \
+	firmware/2lib/2gbb.c \
 	firmware/2lib/2misc.c \
 	firmware/2lib/2nvstorage.c \
 	firmware/2lib/2rsa.c \
-	firmware/2lib/2secdata.c \
-	firmware/2lib/2secdatak.c \
+	firmware/2lib/2secdata_firmware.c \
+	firmware/2lib/2secdata_fwmp.c \
+	firmware/2lib/2secdata_kernel.c \
 	firmware/2lib/2sha1.c \
 	firmware/2lib/2sha256.c \
 	firmware/2lib/2sha512.c \
@@ -363,74 +405,9 @@
 	firmware/2lib/2hmac.c
 
 FWLIB20_SRCS = \
-	firmware/lib20/api.c \
 	firmware/lib20/api_kernel.c \
-	firmware/lib20/common.c \
 	firmware/lib20/kernel.c \
 	firmware/lib20/misc.c \
 	firmware/lib20/packed_key.c
 
 FWLIB21_SRCS = \
-	firmware/lib21/api.c \
-	firmware/lib21/common.c \
-	firmware/lib21/misc.c \
-	firmware/lib21/packed_key.c
-
-BDBLIB_SRCS = \
-	firmware/bdb/bdb.c \
-	firmware/bdb/ecdsa.c \
-	firmware/bdb/misc.c \
-	firmware/bdb/rsa.c \
-	firmware/bdb/secrets.c \
-	firmware/bdb/sha.c \
-	firmware/bdb/stub.c \
-	firmware/bdb/nvm.c
-
-# TPM lightweight command library
-ifeq (${TPM2_MODE},)
-TLCL_SRCS = \
-	firmware/lib/tpm_lite/tlcl.c
-else
-TLCL_SRCS = \
-	firmware/lib/tpm2_lite/tlcl.c \
-	firmware/lib/tpm2_lite/marshaling.c
-endif
-TLCL_OBJS_FOR_TEST = $(TLCL_SRCS:%.c=${BUILD}/%_for_test.o)
-
-# Support real TPM unless BIOS sets MOCK_TPM
-ifeq (${MOCK_TPM},)
-VBINIT_SRCS += \
-	firmware/lib/rollback_index.c \
-	${TLCL_SRCS}
-else
-VBINIT_SRCS += \
-	firmware/lib/mocked_rollback_index.c \
-	firmware/lib/tpm_lite/mocked_tlcl.c
-endif
-
-ifeq (${FIRMWARE_ARCH},)
-# Include BIOS stubs in the firmware library when compiling for host
-# TODO: split out other stub funcs too
-VBINIT_SRCS += \
-	firmware/stub/tpm_lite_stub.c \
-	firmware/stub/vboot_api_stub_init.c \
-	firmware/stub/vboot_api_stub_region.c
-
-VBSLK_SRCS += \
-	firmware/stub/vboot_api_stub.c \
-	firmware/stub/vboot_api_stub_disk.c \
-	firmware/stub/vboot_api_stub_stream.c
-
-FWLIB2X_SRCS += \
-	firmware/2lib/2stub.c
-
-endif
-
-VBSF_SRCS += ${VBINIT_SRCS}
-FWLIB_SRCS += ${VBSF_SRCS} ${VBSLK_SRCS}
-
-VBINIT_OBJS = ${VBINIT_SRCS:%.c=${BUILD}/%.o}
-VBSF_OBJS = ${VBSF_SRCS:%.c=${BUILD}/%.o}
-ALL_OBJS +=  ${VBINIT_OBJS} ${VBSF_OBJS}
-
-FWLIB_OBJS = ${FWLIB_SRCS:%.c=${BUILD}/%.o}

## vboot-utils 0~R81-12871.B

=== debian/changelog ===
vboot-utils (0~R81-12871.B-1) unstable; urgency=medium

  * Update debian/watch
  * New upstream version 0~R81-12871.B
  * Refresh patches
  * Build with clang and libfuzzer
  * d/rules: remove futility_s mention (no longer exists)
  * Add a patch to remove -Werror flag
  * Use debhelper-compat 12
  * Remove useless python in build-dep (Closes: #938769)
  * Add missing build-dep bc required for tests
  * Update debian/copyright
  * Add missing flags pie
  * Bump Standards-Version to 4.5.0

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 12 Feb 2020 15:14:54 +0100

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,21 @@
 Source: vboot-utils
 Section: admin
 Priority: optional
-Maintainer: Sophie Brun <sophie@freexian.com>
+Maintainer: Sophie Brun <sophie@offensive-security.com>
 Uploaders: Raphaël Hertzog <hertzog@debian.org>
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper-compat (= 12),
+               clang-9,
+               libfuzzer-9-dev,
                liblzma-dev,
                libssl-dev,
                libyaml-dev,
                pkg-config,
                uuid-dev,
-# tests/bitmaps/TestBmpBlock.py
-               python,
+# tests/subprocess_tests.c
+               bc,
 # tests/external_rsa_signer.sh
                openssl
-Standards-Version: 4.1.3
+Standards-Version: 4.5.0
 Vcs-Git: https://salsa.debian.org/debian/vboot-utils.git
 Vcs-Browser: https://salsa.debian.org/debian/vboot-utils
 Homepage: https://chromium.googlesource.com/chromiumos/platform/vboot_reference

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,7 @@
 #!/usr/bin/make -f
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export CC = clang-9
 
 override_dh_auto_build:
 	dh_auto_build -- V=1
@@ -15,8 +16,6 @@
 	        $$(pwd)/debian/vboot-utils/usr/bin/vbutil_kernel
 	mv -t $$(pwd)/debian/vboot-kernel-utils/usr/bin \
 	        $$(pwd)/debian/vboot-utils/usr/bin/futility
-	mv -t $$(pwd)/debian/vboot-kernel-utils/usr/bin \
-	        $$(pwd)/debian/vboot-utils/usr/bin/futility_s
 	# vboot_host.pc is useless without the static library (which
 	# we could install with "make install-dev" but we currently don't)
 	rm -f debian/vboot-utils/usr/lib/pkgconfig/vboot_host.pc
@@ -28,7 +27,7 @@
 endif
 
 %:
-	dh $@ --parallel
+	dh $@
 
 override_dh_fixperms:
 	dh_fixperms

=== debian/watch ===
version=3
opts="downloadurlmangle=s|/\+/release-(.*)|/+archive/release-$1.tar.gz|g,uversionmangle=s|^|0~|,filenamemangle=s|.*/release-(.*)$|vboot-utils-$1.tar.gz|" \
https://chromium.googlesource.com/chromiumos/platform/vboot_reference/+refs \
 /chromiumos/platform/vboot_reference/\+/refs/heads/release-(.*)

## vboot-utils 0~R88

=== Makefile ===
--- 
+++ 
@@ -43,7 +43,7 @@
 
 # Stuff for 'make install'
 INSTALL = install
-DESTDIR = /usr/local
+DESTDIR = /
 LIBDIR ?= lib
 
 # Default values
@@ -56,17 +56,6 @@
 #  US_DIR = shared data directory (for static content like devkeys)
 #  DF_DIR = utility defaults directory
 #  VB_DIR = vboot binary directory for dev-mode-only scripts
-ifeq (${MINIMAL},)
-# Host install just puts everything where it's told
-UB_DIR=${DESTDIR}/bin
-UL_DIR=${DESTDIR}/${LIBDIR}
-ULP_DIR=${UL_DIR}/pkgconfig
-UI_DIR=${DESTDIR}/include/vboot
-US_DIR=${DESTDIR}/share/vboot
-DF_DIR=${DESTDIR}/default
-VB_DIR=${DESTDIR}/bin
-else
-# Target install puts things into different places
 UB_DIR=${DESTDIR}/usr/bin
 UL_DIR=${DESTDIR}/usr/${LIBDIR}
 ULP_DIR=${UL_DIR}/pkgconfig
@@ -74,10 +63,12 @@
 US_DIR=${DESTDIR}/usr/share/vboot
 DF_DIR=${DESTDIR}/etc/default
 VB_DIR=${US_DIR}/bin
-endif
 
 # Where to install the (exportable) executables for testing?
 TEST_INSTALL_DIR = ${BUILD}/install_for_test
+
+# Set when installing into the SDK instead of building for a board sysroot.
+SDK_BUILD ?=
 
 # Verbose? Use V=1
 ifeq (${V},)
@@ -96,7 +87,7 @@
 HOST_ARCH ?= ${_machname}
 
 # ARCH and/or FIRMWARE_ARCH are defined by the Chromium OS ebuild.
-# Pick a sane target architecture if none is defined.
+# Pick a valid target architecture if none is defined.
 ifeq (${ARCH},)
   ARCH := ${HOST_ARCH}
 endif
@@ -113,9 +104,15 @@
   override ARCH := x86_64
 endif
 
+ifneq ($(wildcard host/arch/${ARCH}/lib/crossystem_arch.c),)
+	CROSSYSTEM_ARCH_C := host/arch/${ARCH}/lib/crossystem_arch.c
+else
+	CROSSYSTEM_ARCH_C := host/arch/stub/lib/crossystem_arch.c
+endif
+
 # FIRMWARE_ARCH is only defined by the Chromium OS ebuild if compiling
-# for a firmware target (such as u-boot or depthcharge). It must map
-# to the same consistent set of architectures as the host.
+# for a firmware target (coreboot or depthcharge). It must map to the same
+# consistent set of architectures as the host.
 ifeq (${FIRMWARE_ARCH},i386)
   override FIRMWARE_ARCH := x86
 else ifeq (${FIRMWARE_ARCH},amd64)
@@ -126,15 +123,6 @@
 
 # Provide default CC and CFLAGS for firmware builds; if you have any -D flags,
 # please add them after this point (e.g., -DVBOOT_DEBUG).
-#
-# TODO(crosbug.com/16808) We hard-code u-boot's compiler flags here just
-# temporarily. As we are still investigating which flags are necessary for
-# maintaining a compatible ABI, etc. between u-boot and vboot_reference.
-#
-# As a first step, this makes the setting of CC and CFLAGS here optional, to
-# permit a calling script or Makefile to set these.
-#
-# Flag ordering: arch, then -f, then -m, then -W
 DEBUG_FLAGS := $(if ${DEBUG},-g -O0,-g -Os)
 WERROR := -Werror
 FIRMWARE_FLAGS := -nostdinc -ffreestanding -fno-builtin -fno-stack-protector
@@ -144,7 +132,8 @@
 	-Wno-address-of-packed-member -ffunction-sections -fdata-sections \
 	-Wimplicit-fallthrough -Wformat -Wno-format-security ${DEBUG_FLAGS}
 
-# Note: FIRMWARE_ARCH is defined by the Chromium OS ebuild.
+# FIRMWARE_ARCH is defined if compiling for a firmware target
+# (coreboot or depthcharge).
 ifeq (${FIRMWARE_ARCH},arm)
 CC ?= armv7a-cros-linux-gnueabihf-gcc
 CFLAGS ?= -march=armv5 -fno-common -ffixed-r8 -mfloat-abi=hard -marm
@@ -165,7 +154,7 @@
 endif
 
 # Needs -Wl because LD is actually set to CC by default.
-LDFLAGS ?= -Wl,--gc-sections
+LDFLAGS += -Wl,--gc-sections
 
 ifneq (${DEBUG},)
 CFLAGS += -DVBOOT_DEBUG
@@ -183,18 +172,11 @@
 CFLAGS += -DTPM2_MODE
 endif
 
-# Enable USB boot when switching to dev mode
-ifneq ($(filter-out 0,${USB_BOOT_ON_DEV}),)
-CFLAGS += -DUSB_BOOT_ON_DEV=1
-else
-CFLAGS += -DUSB_BOOT_ON_DEV=0
-endif
-
-# EC software sync is slow to update. Enable warning screen display.
-ifneq ($(filter-out 0,${EC_SLOW_UPDATE}),)
-CFLAGS += -DEC_SLOW_UPDATE=1
-else
-CFLAGS += -DEC_SLOW_UPDATE=0
+# Enable boot from external disk when switching to dev mode
+ifneq ($(filter-out 0,${BOOT_EXTERNAL_ON_DEV}),)
+CFLAGS += -DBOOT_EXTERNAL_ON_DEV=1
+else
+CFLAGS += -DBOOT_EXTERNAL_ON_DEV=0
 endif
 
 # Enable EC early firmware selection.
@@ -207,6 +189,27 @@
 # Some tests need to be disabled when using mocked_secdata_tpm.
 ifneq (${MOCK_TPM},)
 CFLAGS += -DMOCK_TPM
+endif
+
+# TPM2_SIMULATOR indicates whether the TPM2 simulator feature is enable or not.
+ifneq ($(filter-out 0,${TPM2_SIMULATOR}),)
+CFLAGS += -DTPM2_SIMULATOR=1
+else
+CFLAGS += -DTPM2_SIMULATOR=0
+endif
+
+# DETACHABLE indicates whether the device is a detachable or not.
+ifneq ($(filter-out 0,${DETACHABLE}),)
+CFLAGS += -DDETACHABLE=1
+else
+CFLAGS += -DDETACHABLE=0
+endif
+
+# Enable the menu-based user interface.
+ifneq ($(filter-out 0,${MENU_UI}),)
+CFLAGS += -DMENU_UI=1
+else
+CFLAGS += -DMENU_UI=0
 endif
 
 # LEGACY_MENU_UI controls whether to enable legacy menu UI, which is used with
@@ -218,16 +221,18 @@
 CFLAGS += -DLEGACY_MENU_UI=0
 endif
 
-# enable all features during local compile (permits testing)
-ifeq (${FIRMWARE_ARCH},)
-DIAGNOSTIC_UI := 1
-endif
-
 # pass DIAGNOSTIC_UI= (or =0) to make to disable feature
 ifneq ($(filter-out 0,${DIAGNOSTIC_UI}),)
 CFLAGS += -DDIAGNOSTIC_UI=1
 else
 CFLAGS += -DDIAGNOSTIC_UI=0
+endif
+
+# Confirm physical presence using keyboard
+ifneq ($(filter-out 0,${PHYSICAL_PRESENCE_KEYBOARD}),)
+CFLAGS += -DPHYSICAL_PRESENCE_KEYBOARD=1
+else
+CFLAGS += -DPHYSICAL_PRESENCE_KEYBOARD=0
 endif
 
 # NOTE: We don't use these files but they are useful for other packages to
@@ -325,8 +330,9 @@
 
 # Default target.
 .PHONY: all
-all: $(if ${NO_BUILD_TOOLS},,fwlib fwlib2x fwlib20 fwlib21 tlcl) \
-	$(if ${FIRMWARE_ARCH},,host_stuff) \
+all: fwlib futil utillib hostlib cgpt tlcl \
+	$(if ${SDK_BUILD},utils_sdk,utils_board) \
+	$(if $(filter x86_64,${ARCH}),$(if $(filter clang,${CC}),fuzzers)) \
 	$(if ${COV},coverage)
 
 ##############################################################################
@@ -346,7 +352,7 @@
 # TPM commands and various external functions that are provided by the BIOS.
 ifeq (${FIRMWARE_ARCH},)
 INCLUDES += -Ihost/include -Ihost/lib/include
-INCLUDES += -Ihost/lib21/include -Ifirmware/lib21/include
+INCLUDES += -Ihost/lib21/include
 endif
 
 # Firmware library, used by the other firmware components (depthcharge,
@@ -354,45 +360,23 @@
 # this source tree locally and link to it directly.
 FWLIB = ${BUILD}/vboot_fw.a
 
-# Smaller firmware library common to all vboot 2.x, used only for
-# 1) compile-time tests of the public API or
-# 2) linking with an actual 2.0 or 2.1 implementation
-FWLIB2X = ${BUILD}/vboot_fw2x.a
-
-# Vboot 2.0 (deprecated - see firmware/README)
-FWLIB20 = ${BUILD}/vboot_fw20.a
-# Vboot 2.1 (not yet ready - see firmware/README)
-FWLIB21 = ${BUILD}/vboot_fw21.a
-
 # Separate TPM lightweight command library (TLCL)
 TLCL = ${BUILD}/tlcl.a
 
-# Additional firmware library sources needed by VbSelectAndLoadKernel() call
 FWLIB_SRCS = \
-	firmware/lib/cgptlib/cgptlib.c \
-	firmware/lib/cgptlib/cgptlib_internal.c \
-	firmware/lib/cgptlib/crc32.c \
-	firmware/lib/gpt_misc.c \
-	firmware/lib/utility_string.c \
-	firmware/lib/vboot_api_kernel.c \
-	firmware/lib/vboot_audio.c \
-	firmware/lib/vboot_display.c \
-	firmware/lib/vboot_kernel.c \
-	firmware/lib/vboot_ui.c \
-	firmware/lib/vboot_ui_common.c \
-	firmware/lib/vboot_ui_menu.c
-
-# Code common to both vboot 2.0 (old structs) and 2.1 (new structs)
-FWLIB2X_SRCS = \
 	firmware/2lib/2api.c \
 	firmware/2lib/2auxfw_sync.c \
 	firmware/2lib/2common.c \
 	firmware/2lib/2context.c \
 	firmware/2lib/2crc8.c \
+	firmware/2lib/2crypto.c \
 	firmware/2lib/2ec_sync.c \
 	firmware/2lib/2gbb.c \
+	firmware/2lib/2hmac.c \
+	firmware/2lib/2kernel.c \
 	firmware/2lib/2misc.c \
 	firmware/2lib/2nvstorage.c \
+	firmware/2lib/2recovery_reasons.c \
 	firmware/2lib/2rsa.c \
 	firmware/2lib/2secdata_firmware.c \
 	firmware/2lib/2secdata_fwmp.c \
@@ -401,13 +385,40 @@
 	firmware/2lib/2sha256.c \
 	firmware/2lib/2sha512.c \
 	firmware/2lib/2sha_utility.c \
+	firmware/2lib/2stub_hwcrypto.c \
 	firmware/2lib/2tpm_bootmode.c \
-	firmware/2lib/2hmac.c
-
-FWLIB20_SRCS = \
+	firmware/2lib/2ui.c \
+	firmware/2lib/2ui_screens.c \
+	firmware/lib/cgptlib/cgptlib.c \
+	firmware/lib/cgptlib/cgptlib_internal.c \
+	firmware/lib/cgptlib/crc32.c \
+	firmware/lib/gpt_misc.c \
+	firmware/lib/vboot_api_kernel.c \
+	firmware/lib/vboot_audio.c \
+	firmware/lib/vboot_kernel.c \
+	firmware/lib/vboot_ui_legacy.c \
+	firmware/lib/vboot_ui_legacy_clamshell.c \
+	firmware/lib/vboot_ui_legacy_menu.c \
+	firmware/lib/vboot_ui_legacy_wilco.c \
 	firmware/lib20/api_kernel.c \
 	firmware/lib20/kernel.c \
 	firmware/lib20/misc.c \
 	firmware/lib20/packed_key.c
 
-FWLIB21_SRCS = \
+# TPM lightweight command library
+ifeq (${TPM2_MODE},)
+TLCL_SRCS = \
+	firmware/lib/tpm_lite/tlcl.c
+else
+# TODO(apronin): tests for TPM2 case?
+TLCL_SRCS = \
+	firmware/lib/tpm2_lite/tlcl.c \
+	firmware/lib/tpm2_lite/marshaling.c
+endif
+
+# Support real TPM unless MOCK_TPM is set
+ifneq (${MOCK_TPM},)
+FWLIB_SRCS += \
+	firmware/lib/tpm_lite/mocked_tlcl.c
+endif
+

## vboot-utils 0~R88-13597.B

=== debian/changelog ===
vboot-utils (0~R88-13597.B-1) unstable; urgency=medium

  [ Sophie Brun ]
  * Add a patch to fix reproducible build (Closes: #974863)
  * Upgrade to clang-11 (Closes: #974776)
  * Bump Standards-Version to 4.5.1 (no changes)
  * Use version=4 in debian/watch
  * New upstream version 0~R88-13597.B
  * Refresh patches

  [ Raphael Hertzog ]
  * Use libfuzzer-11-dev instead of libfuzzer-10-dev

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 01 Dec 2020 10:59:21 +0100

vboot-utils (0~R87-13505.B-1) unstable; urgency=medium

  * New upstream version 0~R87-13505.B
  * Refresh patches
  * Add a patch to not embed user and time in version (Closes: #971400)
  * Switch to clang 10 (Closes: #971402)
  * Remove override_dh_fixperms no longer needed
  * Update installation for new upstream release

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 27 Oct 2020 21:01:46 +0100

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,10 @@
 Section: admin
 Priority: optional
 Maintainer: Sophie Brun <sophie@offensive-security.com>
-Uploaders: Raphaël Hertzog <hertzog@debian.org>
+Uploaders: Raphaël Hertzog <raphael@offensive-security.com>
 Build-Depends: debhelper-compat (= 12),
-               clang-9,
-               libfuzzer-9-dev,
+               clang-11,
+               libfuzzer-11-dev,
                liblzma-dev,
                libssl-dev,
                libyaml-dev,
@@ -15,7 +15,7 @@
                bc,
 # tests/external_rsa_signer.sh
                openssl
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Vcs-Git: https://salsa.debian.org/debian/vboot-utils.git
 Vcs-Browser: https://salsa.debian.org/debian/vboot-utils
 Homepage: https://chromium.googlesource.com/chromiumos/platform/vboot_reference

=== debian/rules ===
--- 
+++ 
@@ -1,13 +1,14 @@
 #!/usr/bin/make -f
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-export CC = clang-9
+export CC = clang-11
+export _machname = $(DEB_HOST_ARCH)
 
 override_dh_auto_build:
 	dh_auto_build -- V=1
 
 override_dh_auto_install:
-	$(MAKE) V=1 DESTDIR=$$(pwd)/debian/vboot-utils/usr install
+	$(MAKE) V=1 DESTDIR=$$(pwd)/debian/vboot-utils install
 	mkdir -p $$(pwd)/debian/cgpt/usr/bin
 	mv -t $$(pwd)/debian/cgpt/usr/bin \
 	        $$(pwd)/debian/vboot-utils/usr/bin/cgpt
@@ -20,6 +21,7 @@
 	# we could install with "make install-dev" but we currently don't)
 	rm -f debian/vboot-utils/usr/lib/pkgconfig/vboot_host.pc
 	rmdir --ignore-fail-on-non-empty -p debian/vboot-utils/usr/lib/pkgconfig
+	rm -f debian/vboot-utils/usr/lib/libvboot_host.a
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
@@ -28,7 +30,3 @@
 
 %:
 	dh $@
-
-override_dh_fixperms:
-	dh_fixperms
-	chmod 755 debian/vboot-utils/usr/share/vboot/bin/common_minimal.sh
